<template>
  <div class="create-post">
    <PostTitle title="Novo Post"/>

    <form class="form" method="post">
      <label class="form__label" for="post-title">Título do seu post</label>
      <input class="form__input form__input--title" type="text" name="post-title" placeholder="Lorem ipsum dolor sit amet.">
      <label class="form__label" for="post-content">Conteúdo do seu post</label>
      <textarea class="form__textarea" name="post-content" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit. Nam fugiat cupiditate minima ab? Illum adipisci itaque, nisi consequatur ea libero!"></textarea>
      <button class="form__button" name="post-button" v-on:click="createPost">Criar Post</button>
    </form>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator';
import axios from 'axios';
import PostTitle from '@/components/PostTitle.vue'; // @ is an alias to /src

@Component({
  components: {
    PostTitle,
  },
})

export default class CreatePost extends Vue {

  public data() {
    return {
    };
  }

  public async createPost(e) {
    e.preventDefault();

    const postTitle = document.querySelector('.form__input');
    const postContent = document.querySelector('.form__textarea');
    const postDate = new Date();
    const hour = '' + postDate.getHours() + ':' + postDate.getMinutes();
    const date = '' + postDate.getDate() + '/' + postDate.getMonth() + '/' + postDate.getFullYear() + '';
    const postDateFormated = '' + hour + ' ' + date;

    const result = await axios({
      url: 'http://localhost:4020/graphql',
      method: 'post',
      data: {
          query: `
            mutation createPost{
                createPost(
                  data:{
                    title: "${postTitle.value}"
                    body: "${postContent.value}"
                    author: "user_id"
                    likes: 0
                    timestamp: "${postDateFormated}"
                  }
                ){
                  _id
                  title
                  body
                  author
                  likes
                  timestamp
                }
            }`,
      },
    });

    const postID = result.data.data.createPost._id;

    this.$router.push('/post/' + postID + '');
  }

}
</script>

<style>

  .form {
    @apply mt-5 mb-10 p-10 shadow w-full bg-white text-left;
  }


  .form__label {
    @apply block mt-3 mb-5 pb-1 border-b border-gray-400 text-xl font-bold uppercase;
  }

  .form__input,
  .form__textarea {
    @apply mb-5 pt-2 pb-2 pl-5 pr-5 border-solid border border-gray-400 w-full outline-none;
  }

  .form__textarea {
    @apply h-48;
  }

  .form__button {
    @apply text-white bg-blue-400 pb-2 pt-2 pl-5 pr-5 rounded-full outline-none;
  }

</style>
